/***************************************************************************
 *   Copyright (C) 1980-2005 Artur Wiebe                                   *
 *   artur@wiebenet.de                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "computerplayer.h"


myComputerPlayer::myComputerPlayer(bool white, int rules, const QString& name)
    : myPlayer(white, rules)
{
    setName(name);

    thread = 0;
}


myComputerPlayer::~myComputerPlayer()
{
    if(thread)
	thread->stop();
}


void myComputerPlayer::yourTurn(Checkers* game)
{
    if(thread)
	qDebug("myComputerPlayer::yourTurn: a thread exists.");

    thread = new myThread(this, game);
    thread->start();
}


void myComputerPlayer::stop()
{
    if(thread)
	thread->stop();

    emit stopped();
}


bool myComputerPlayer::event(QEvent* ev)
{
    if(ev->type() == QEvent::MaxUser) {
	thread->wait();

	delete thread;
	thread = 0;

	emit moveDone(QString::null);//aw???game->toString(false));
	return true;
    }

    QObject::event(ev);
    return false;
}

