/***************************************************************************
 *   Copyright (C) 1980-2005 Artur Wiebe                                   *
 *   artur@wiebenet.de                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#ifndef _CONSOLE_H_
#define _CONSOLE_H_

#include <qframe.h>
#include <qtextedit.h> 
#include <qlineedit.h>
#include <qstring.h>
#include <qpushbutton.h>
#include <qlabel.h>


    // message types
#define MSG_SYSTEM	0	// are bold
#define MSG_USER	1	// are blue
#define MSG_OPPONENT	2	// are red
#define MSG_LOG		3	// are not highlighted
#define MSG_FATAL	4	// are bold/red/underline

class myConsole : public QFrame
{
    Q_OBJECT

public:
    myConsole(QWidget* parent);

signals:
    void sendText(const QString&);
    void updated();

public slots:
    void message(int msg_type, const QString&);
    void clear();

private slots:
    void slotSendMsg();
    void save();

private:
    QTextEdit* m_log;
    QLineEdit* m_input;
};


#endif
