/***************************************************************************
 *   Copyright (C) 2002-2003 Andi Peredri                                  *
 *   andi@ukr.net                                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include <qpainter.h>

#include "field.h"


Field::Field(QWidget* parent,int i)
    : QWidget(parent)
{
    //????????? 64?
    pixmap = new QPixmap(64, 64);

    m_number=i;

    m_pattern=NULL;
    m_checker=NULL;
    m_frame=NULL;

    show_frame = false;
}


void Field::paintEvent(QPaintEvent*)
{
    bitBlt(this, 0, 0, pixmap);
}


void Field::mousePressEvent(QMouseEvent* mouseevent)
{
    if(mouseevent->button()!=Qt::LeftButton)
	return;
    emit click(m_number);
}


void Field::draw()
{
    QPainter paint;
    paint.begin(pixmap);

    if(m_pattern)
	paint.drawPixmap(0, 0, *m_pattern);

    if(m_label.length()) {
        paint.setPen(white);
        paint.setFont(QFont(font().family(), 8));
        paint.drawText(2, 11, m_label);
    }

    if(m_checker)
	paint.drawPixmap(0, 0, *m_checker);

    if(show_frame)
	paint.drawPixmap(0, 0, *m_frame);

    paint.end();
    update();
}


void Field::setFrame(QPixmap* xpm)
{
    m_frame = xpm;
}


void Field::showFrame(bool b)
{
    if(show_frame != b) {
	show_frame = b;
	draw();
    }
}


void Field::setPicture(QPixmap* xpm)
{
    if(m_checker!=xpm) {
	m_checker = xpm;
	draw();
    }
}


void Field::setPattern(QPixmap* xpm)
{
    if(m_pattern != xpm) {
	m_pattern = xpm;
	draw();
    }
}


void Field::setLabel(const QString& str)
{
    if(m_label != str) {
	m_label=str;
	draw();
    }
}

