#include <qapplication.h>
#include <qtranslator.h>
#include <qtextcodec.h>


#include "toplevel.h"
#include "config.h"


int main(int argc, char *argv[])
{
    QApplication app(argc,argv);

    qDebug("Your Locale: %s\nLocale path: %s",
	    QTextCodec::locale(), SHARE_PATH);

    // Qt translations
    QTranslator qt_tr(0);
    if(!qt_tr.load(QString("qt_") + QTextCodec::locale(), "."))
	qWarning("Loading Qt translations failed.");
    else
	app.installTranslator(&qt_tr);

    // App translations
    QTranslator app_tr(0);
    if(!app_tr.load(QString("kcheckers_") + QTextCodec::locale(), SHARE_PATH))
	qWarning("Loading KCheckers translations failed.");
    else
	app.installTranslator(&app_tr);

    myTopLevel* top = new myTopLevel();
    app.setMainWidget(top);
    top->show();

    int exit = app.exec();

    delete top;
    return exit;
}


