/***************************************************************************
 *   Copyright (C) 2002-2003 Andi Peredri                                  *
 *   andi@ukr.net                                                          *
 *   Copyright (C) 1980-2005 Artur Wiebe                                   *
 *   artur@wiebenet.de                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PDNPREVIEW_H
#define PDNPREVIEW_H

#include <qlistbox.h>
#include <qfiledialog.h>
#include <qlabel.h>
#include <qframe.h>
#include <qcheckbox.h>


class Pdn;


// Portable Draughts Notation preview widget

class PdnPreview : public QFrame, public QFilePreview
{
    Q_OBJECT

public:
    PdnPreview(QWidget* parent);
    ~PdnPreview();

    virtual void previewUrl(const QUrl &url);

    int currentItem() const { return lb->currentItem(); }
    bool boardOnly() const { return m_boardonly->isChecked(); }

    // converts game type(RUSSIAN / ENGLISH) to a human readable string.
    static QString typeToString(int type);

signals:
    void selected(int);

private slots:
    void slotInfo(int);

private:
    QListBox* lb;
    QLabel* m_white;
    QLabel* m_black;
    QLabel* m_type;
    QLabel* m_event;
    QCheckBox* m_boardonly;

    Pdn* pdn;
};

#endif

