/***************************************************************************
 *   Copyright (C) 2002-2003 Andi Peredri                                  *
 *   andi@ukr.net                                                          *
 *   Copyright (C) 1980-2005 Artur Wiebe                                   *
 *   artur@wiebenet.de                                                     *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef _TOPLEVEL_H_
#define _TOPLEVEL_H_

#include <qmainwindow.h>


class myServerSocket;
class myClientSocket;
class myConsole;
class myView;
class myNewGameDlg;

class QAction;


class myTopLevel : public QMainWindow
{
    Q_OBJECT

public:
    myTopLevel();

protected:
    void closeEvent(QCloseEvent*);

private slots:
    void slotHelp();
    void slotAbout();

    void slotNewGame();
    void slotOpenGame();
    void slotSaveGame();
    void slotGameInfo();
    void slotNextRound();

    void slotShowConsole();
    void slotConsoleUpdated();

    void slotEnableUndo(bool);
    void slotWorking(bool);

    void setPattern();

    void warning(const  QString& text);


private:
    void make_actions();
    void restore_settings();
    void make_checkers_board();

    void information(const QString& caption, const QString& text);

    QString actionToPattern();
    QString actionToSize();
    QAction* patternToAction(const QString&);
    QAction* sizeToAction(const QString&);

    // returns true if the user wishes to keep current game
    bool keepGame();

private:
    bool undo;

    QPopupMenu* viewMenu;
    //
    QAction* gameNew;
    QAction* gameUndo;
    QAction* gameStop;
    QAction* gameOpen;
    QAction* gameSave;
    QAction* gameNextRound;
    //
    QAction* viewNotation;
    QAction* viewMarble;
    QAction* viewWooden;
    QAction* viewGreen;
    QAction* viewSmall;
    QAction* viewBig;
    QAction* viewConsole;
    //
    QAction* settingsConsole;
    QAction* settingsKeep;

    QString filename;      // PDN File Name

    myView* view;
    myConsole* m_console;
    myNewGameDlg* m_newgame;
};

#endif

